> ## Documentation Index
> Fetch the complete documentation index at: https://developers.criteo.com/llms.txt
> Use this file to discover all available pages before exploring further.

# /experimental/retail-media/line-items/{line-item-id}/products/add

> Add products to a line item.



## OpenAPI

````yaml https://api.criteo.com/experimental/retailmedia/open-api-specifications.json post /experimental/retail-media/line-items/{line-item-id}/products/add
openapi: 3.0.1
info:
  title: Criteo API
  description: Criteo API - RetailMedia
  version: Experimental
servers:
  - url: https://api.criteo.com
security:
  - oauth: []
tags:
  - name: Accounts
  - name: Analytics
  - name: Audience
  - name: Balance
  - name: Campaign
  - name: Catalog
  - name: Gateway
  - name: OnSiteRecommendation
  - name: ThirdPartyAccounts
paths:
  /experimental/retail-media/line-items/{line-item-id}/products/add:
    post:
      tags:
        - Campaign
      summary: /experimental/retail-media/line-items/{line-item-id}/products/add
      description: Add products to a line item.
      operationId: AddProducts
      parameters:
        - name: line-item-id
          in: path
          description: The line item id.
          required: true
          schema:
            type: string
      requestBody:
        description: The products to add.
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/AddProductsModelRequest'
        required: true
      responses:
        '200':
          description: Success
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/AddProductsResultModelResponse'
      security:
        - oauth:
            - RetailMedia_Campaign_Manage
components:
  schemas:
    AddProductsModelRequest:
      type: object
      properties:
        data:
          $ref: '#/components/schemas/AddProductsModelResource'
      additionalProperties: false
      description: >-
        A top-level object that encapsulates a Criteo API request for a single
        value object.
    AddProductsResultModelResponse:
      type: object
      properties:
        data:
          $ref: '#/components/schemas/AddProductsResultModelResource'
        errors:
          type: array
          items:
            $ref: '#/components/schemas/CommonProblem'
          description: Errors that occured during this call.
          nullable: true
          readOnly: true
        warnings:
          type: array
          items:
            $ref: '#/components/schemas/CommonProblem'
          description: Warnings that occured during this call.
          nullable: true
          readOnly: true
      additionalProperties: false
      description: >-
        A top-level object that encapsulates a Criteo API response for a single
        value object.
    AddProductsModelResource:
      type: object
      properties:
        attributes:
          $ref: '#/components/schemas/AddProductsModel'
        type:
          type: string
          description: Type of the resource.
          nullable: true
      additionalProperties: false
      description: A value resource exposed by the API.
    AddProductsResultModelResource:
      type: object
      properties:
        attributes:
          $ref: '#/components/schemas/AddProductsResultModel'
        type:
          type: string
          description: Type of the resource.
          nullable: true
      additionalProperties: false
      description: A value resource exposed by the API.
      nullable: true
    CommonProblem:
      type: object
      properties:
        code:
          type: string
          description: A machine-readable error code, expressed as a string value.
          nullable: true
        detail:
          type: string
          description: >-
            A human-readable explanation specific to this occurrence of the
            problem
          nullable: true
        instance:
          type: string
          description: A URI that identifies the specific occurrence of the problem.
          nullable: true
        source:
          type: object
          additionalProperties:
            type: string
          description: >-
            A machine-readable structure to reference to the exact location(s)
            causing the error(s)
          nullable: true
        stackTrace:
          type: string
          nullable: true
        title:
          type: string
          description: A short human-readable description of the problem type
          nullable: true
        traceId:
          type: string
          description: The request correlation ID this problem comes from.
          nullable: true
        traceIdentifier:
          type: string
          description: >-
            The request correlation ID this problem comes from. (deprecated, use
            traceId instead)
          nullable: true
        type:
          enum:
            - unknown
            - access-control
            - authentication
            - authorization
            - availability
            - deprecation
            - quota
            - validation
          type: string
          description: The problem's category.
          nullable: true
      description: Common problem object.
    AddProductsModel:
      type: object
      properties:
        displayProductDetails:
          maxItems: 1500
          type: array
          items:
            $ref: '#/components/schemas/ProductModel'
          description: The display products to add to the line item.
          nullable: true
        productType:
          enum:
            - DisplayProduct
            - SponsoredProduct
          type: string
          description: The type of product being added.
          default: DisplayProduct
      additionalProperties: false
      description: The products to add to a line item.
    AddProductsResultModel:
      type: object
      properties:
        displayProductDetails:
          type: array
          items:
            $ref: '#/components/schemas/DisplayProductResultModel'
          description: The display products added to the line item.
          nullable: true
        productType:
          enum:
            - DisplayProduct
            - SponsoredProduct
          type: string
          description: The type of product that was added.
          nullable: true
      additionalProperties: false
      description: The result of adding products to a line item.
      nullable: true
    ProductModel:
      type: object
      properties:
        productId:
          type: string
          description: The identifier of the product.
          nullable: true
      additionalProperties: false
      description: A product associated with a line item.
    DisplayProductResultModel:
      type: object
      properties:
        approvalStatus:
          enum:
            - Unknown
            - Approved
            - AutoApproved
            - InReview
            - Rejected
            - AutoRejected
            - Unsubmitted
          type: string
          description: The approval status of the product.
          nullable: true
        productId:
          type: string
          description: The identifier of the product.
          nullable: true
      additionalProperties: false
      description: A display product returned after being added to a line item.
  securitySchemes:
    oauth:
      type: oauth2
      flows:
        clientCredentials:
          tokenUrl: https://api.criteo.com/oauth2/token
          scopes: {}
        authorizationCode:
          authorizationUrl: https://api.criteo.com/oauth2
          tokenUrl: https://api.criteo.com/oauth2/token
          scopes: {}

````